import "WalmPlugins.PimpYourText.DropDown";
import "WalmPlugins.PimpYourText.UTF";
import "WalmPlugins.PimpYourText.Tooltip";

PimpYourTextDialog = class( Turbine.UI.Lotro.Window );

function PimpYourTextDialog:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	
	self:SetSize( 350, 220 );
	self:SetPosition( settings.main_x, settings.main_y);
	self:SetVisible(false);
	
	self:SetText( "Pimp Your Text !" );	
	
	-- Build GUI and logicals
	self:CreateComponents();
	
	self.PositionChanged = function(sender, args)
		settings.main_x, settings.main_y = self:GetPosition();
		Savesettings();
	end	
	
	self.Closed = function(sender, args)
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>Fermeture de PimpYourText. Pour le r\195\169ouvrir, tapez la commande /PimpYourText show !</rgb>");
		self:Stop();
	end
end

function PimpYourTextDialog:CreateComponents()
	-- Custom text to send
	self.textArea = Turbine.UI.Lotro.TextBox();
	self.textArea:SetParent( self );
	self.textArea:SetPosition( 15, 35 );
	self.textArea:SetSize( self:GetWidth()-50, 100 );	
	
	-- BROKEN because of the API
	-- self.textArea:SetWantsKeyEvents(true);
	-- self.textArea.KeyUp = function()
		-- Turbine.Shell.WriteLine("<rgb=#FF0000>TEXT UP : ".. self.textArea:GetText() .."</rgb>");
		-- self:UpdateValidationButton();
	-- end	
	-- self.textArea.KeyDown = function()
		-- Turbine.Shell.WriteLine("<rgb=#FF0000>TEXT UP : ".. self.textArea:GetText() .."</rgb>");
		-- self:UpdateValidationButton();
	-- end
	-- FIX and REPLACE Keys Events, but cause a dblclick issue for validation
	self.textArea.FocusLost = function()
		self:UpdateValidationButton();
	end
	-- API BUG => bad mgnt of scrollbars
	local scrollBar = Turbine.UI.Lotro.ScrollBar();
    scrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    scrollBar:SetParent( self );
    scrollBar:SetPosition( self.textArea:GetLeft()+self.textArea:GetWidth(), self.textArea:GetTop() );
    scrollBar:SetSize( 10, self.textArea:GetHeight() );
	self.textArea:SetVerticalScrollBar( scrollBar );
	if(settings.loadData~=nil and settings.loadData.text~=nil) then
		self.textArea:SetText(settings.loadData.text);
	else
		self.textArea:SetText("Ecrivez ici votre message");
	end	
	
	
	-- Create childs GUIs
	
	self:CreateToolscomponents();
	self:CreateColorComponents();
	self:CreateDestComponents();
	self:CreateGeneratorComponents();
	
	self:UpdateValidationButton();
end

-- Create Color components (DropDown box and textbox) and logical
function PimpYourTextDialog:CreateColorComponents()
	-- Just a label
	local label = Turbine.UI.Label();
	label:SetParent( self );
	label:SetPosition(self.textArea:GetLeft(), self.textArea:GetTop()+self.textArea:GetHeight()+7);
	label:SetSize( 150, 20 );
	label:SetMultiline(false);
	label:SetText("Couleur :");

	-- Textbox with rgb code
	self.colorArea = Turbine.UI.Lotro.TextBox();
	self.colorArea:SetParent( self );
	self.colorArea:SetSize( 70, 20 );
	self.colorArea:SetPosition( self.textArea:GetLeft()+self.textArea:GetWidth()-self.colorArea:GetWidth(), label:GetTop()-2 );	
	self.colorArea:SetMultiline(false);
	self.colorArea:SetText("");
	self.colorArea:SetEnabled(false);
	self.colorArea:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	
	self.colorArea.FocusLost = function ()
		-- Check the rgb code length
		if(string.len(self.colorArea:GetText())~=6) then
			Turbine.Shell.WriteLine("<rgb=#FF0000>PimpYourText ERROR: Custom color should have 6 digits</rgb>");
			self.colorArea:SetText("000000");	
		else
			-- Chek the rgb code format (hexa)
			for i=1, 6, 1 do
				local c = string.byte(self.colorArea:GetText(), i);
				if(not ((c>=48 and c<=57) or (c>=65 and c<=70) or (c>=97 and c<=102) )) then
					Turbine.Shell.WriteLine("<rgb=#FF0000>PimpYourText ERROR: One of the digit is not a valid hexa value</rgb>");
					--self.colorArea:SetText("000000");		
				end
			end
		end
				-- elseif(string.find(self.colorArea:GetText(), "0123456789abcdefABCDEF")~=6) then
			-- Turbine.Shell.WriteLine("<rgb=#FF0000>RichText ERROR: Custom color should have 6 hexa digits</rgb>");
			-- self.colorArea:SetText("");	
		-- Update if necessary the sending button
		self:UpdateValidationButton();
	end
	
	-- Colors combobox
	self.colorList={"Par d\195\169faut", "Blanc", "Rouge", "Jaune", "Vert", "Turquoise", "Rose", "Arc-en-ciel", "Couleur RGB"};
	self.rgbList={"", "FFFFFF", "FF0000", "FFFF00", "00FF00", "38E5DF", "FF5CCD"};
	self.colorid = 1;
	if(settings.loadData~=nil and settings.loadData.color~=nil) then
		self.colorid = settings.loadData.color;
		self.selectedColor = self.colorList[self.colorid];
	end
	--self.selectedColor = self.commandList[self.colorid];	
	self.colorDropDown = DropDown.Create(self.colorList, self.colorList[self.colorid]); -- table that contains the list, default selected value for the list
	self.colorDropDown:SetParent(self);
	self.colorDropDown:SetPosition( self.colorArea:GetLeft()-130, self.colorArea:GetTop());
	self.colorDropDown.myElementList = elementList;
	self.colorDropDown:ApplyWidth(125);
	self.colorDropDown:SetMaxItems(table.getn(self.colorList));
	self.colorDropDown:SetVisible(true);
	self.colorDropDown.ItemChanged = function ()
		for i=1, table.getn(self.colorList), 1 do
			-- fucking loop because of the Combobox API should return the selected id... but NO !
			if(self.colorList[i]==self.colorDropDown:GetText()) then
				-- Validate if the id is not the last
				if(i<table.getn(self.rgbList)+2) then				
					self.colorArea:SetText(self.rgbList[i]);
					self.colorArea:SetEnabled(false);
					self.selectedColor = self.colorDropDown:GetText();
					self:UpdateValidationButton();
				else
					-- User can write is own rgb code
					self.selectedColor = self.colorDropDown:GetText();				
					self.colorArea:SetEnabled(true);
				end
				self.colorid = i;
				break;
			end
		end	
	end
end

-- Create Chanels components (DropDown box and textbox) and logical
function PimpYourTextDialog:CreateDestComponents()
	-- Nice label !
	local label = Turbine.UI.Label();
	label:SetParent( self );
	label:SetPosition(self.textArea:GetLeft(), self.textArea:GetTop()+self.textArea:GetHeight()+37);
	label:SetSize( 150, 20 );
	label:SetMultiline(false);
	label:SetText("Canal :");

	-- Insert in this field your buddy' name
	self.destArea = Turbine.UI.Lotro.TextBox();
	self.destArea:SetParent( self );
	self.destArea:SetPosition( self.colorArea:GetLeft(), self.colorArea:GetTop()+26 );
	self.destArea:SetSize( self.colorArea:GetSize() );
	self.destArea:SetMultiline(false);
	self.destArea:SetText("");
	self.destArea:SetEnabled(false);
	self.destArea:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	
	self.destArea.FocusLost = function ()
		-- Damn, your buddy has an empty name... too cruel to be real !
		if(string.len(self.destArea:GetText())==0) then
			Turbine.Shell.WriteLine("<rgb=#FF0000>PimpYourText ERROR: Le destinataire n'est pas saisi !</rgb>");
		else
			-- Okay, let's update the sending button !
			self:UpdateValidationButton();
		end
	end
	
	-- Combobox with channels list
	self.canalList={"Parler", "Communaut\195\169", "Confr\195\169rie", "Raid", "Monde", "Officier", "MdJ de confrérie", "Canal perso. 1", "Canal perso. 2", "Canal perso. 3", "Canal perso. 4","Canal perso. 5","Canal perso. 6","Canal perso. 7","Canal perso. 8", "MI"};
	
	self.commandList={"/parler", "/f", "/k", "/ra", "/monde", "/off", FromUTF8("/confrérie mdj"), "/1", "/2", "/3", "/4", "/5", "/6", "/7", "/8","/dire"};
	
	-- BUG /conf non reconnu 
	--self.commandList={"/parler", "/comm", "/conf", "/ra", "/monde", "/off", FromUTF8("/confrérie mdj"), "/1", "/2", "/3", "/4", "/5", "/6", "/7", "/8","/dire"};
	--self.commandList={"/parler", "/comm", "/conf", "/ra", FromUTF8("/régional"), FromUTF8("/confrérie mdj"), "/dire"};
	
	--self.commandList={"/parler", "/comm", "/conf", "/ra", "/off", "/cpet rename", "/dire"};
	self.commandid = 1;
	if(settings.loadData~=nil and settings.loadData.command~=nil) then
		self.commandid = settings.loadData.command;
	end
	self.command = self.commandList[self.commandid];
	self.commandDropDown = DropDown.Create(self.canalList, self.canalList[self.commandid]);
	self.commandDropDown:SetParent(self);
	self.commandDropDown:SetPosition( self.destArea:GetLeft()-130, self.destArea:GetTop());
	self.commandDropDown.myElementList = elementList;
	self.commandDropDown:ApplyWidth(125);
	self.commandDropDown:SetMaxItems(11);
	self.commandDropDown:SetVisible(true);
	self.commandDropDown.ItemChanged = function ()
		for i=1, table.getn(self.canalList), 1 do
			-- DAMNED LOOP replacing the combobox lack of returning infos
			if(self.canalList[i]==self.commandDropDown:GetText()) then
				if(i==table.getn(self.commandList)) then
					-- Selected MP, so write your buddy' name
					self.destArea:SetEnabled(true);
					self.destArea:Focus();
					self.command = self.commandList[i];
				else
					-- Selectd basic channel
					self.destArea:SetText("");
					self.destArea:SetEnabled(false);
					self.command = self.commandList[i];
					self:UpdateValidationButton();
				end
				self.commandid = i;
				break;
			end
		end	
	end
end

function PimpYourTextDialog:CreateToolscomponents()
	self.resetBtn = Turbine.UI.Label();
	self.resetBtn:SetParent( self );
	self.resetBtn:SetBackground( "WalmPlugins/PimpYourText/close.jpg" );
	self.resetBtn:SetPosition( self.textArea:GetLeft()+self.textArea:GetWidth()+11, self.textArea:GetTop() + self.textArea:GetHeight()-16 );
	self.resetBtn:SetSize(16, 16);
	--resetBtn:SetMouseVisible( false );
	self.resetBtn:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.resetBtn.tooltip = ToolTip(self.resetBtn, "", "Réinitialisation:\nVide le champ de saisie de texte.", ToolTipLayout.XSMALL_TEXTONLY);
	self.resetBtn.MouseClick = function(sender, args)
		self.textArea:SetText("");
	end
	
	self.saveBtn = Turbine.UI.Label();
	self.saveBtn:SetParent( self );
	self.saveBtn:SetBackground( "WalmPlugins/PimpYourText/plume.jpg" );
	self.saveBtn:SetPosition( self.resetBtn:GetLeft(), self.resetBtn:GetTop() - 18);
	self.saveBtn:SetSize(16, 16);
	self.saveBtn.tooltip = ToolTip(self.saveBtn, "Sauvegarde : ", "Enregistre le texte, le canal et la couleur pour les recharger au prochain lancement.", ToolTipLayout.XSMALL_TEXTONLY);
	self.saveBtn.MouseClick = function(sender, args)
		settings.loadData = {
			text = self.textArea:GetText(),
			color = self.colorid,
			command = self.commandid
		};
		Savesettings();
	end
	self.colortagBtn = Turbine.UI.Label();
	self.colortagBtn:SetParent( self );
	self.colortagBtn:SetBackground( "WalmPlugins/PimpYourText/tag.jpg" );
	self.colortagBtn:SetPosition( self.saveBtn:GetLeft(), self.saveBtn:GetTop() - 18);
	self.colortagBtn:SetSize(16, 16);
	self.colortagBtn.tooltip = ToolTip(self.colortagBtn, "Tag : ", "Rajoute dans le texte (à la position du curseur) une balise de changement de couleur.\nLa couleur correspond à celle séléctionnée dans le menu déroulant des couleurs", ToolTipLayout.SMALL_TEXTONLY);
	self.colortagBtn.MouseClick = function(sender, args)
		-- <rgb=#FF5CCD>
		if(self.selectedColor==self.colorList[table.getn(self.colorList)-1]) then
			Turbine.Shell.WriteLine("<rgb=#FF5CCD>L'ajout de balise de couleur ne peut fonctionner avec le mode Rainbow !</rgb>");
		elseif (self.selectedColor==1) then
			Turbine.Shell.WriteLine("<rgb=#FF5CCD>L'ajout de balise de couleur ne peut fonctionner avec la couleur par défaut !</rgb>");
		else
			if(self.textArea:GetSelectionLength()==0) then
				self.textArea:InsertText("<rgb=#"..self.colorArea:GetText()..">");
			else
				local tmp = self.textArea:GetSelectedText();
				self.textArea:SetSelectedText("<rgb=#"..self.colorArea:GetText()..">"..tmp.."</rgb>");
			end
		end
		self:UpdateValidationButton();
	end	
end

-- Build the sending button
function PimpYourTextDialog:CreateGeneratorComponents()
	-- This is the Quickslot, the shortcut container
	self.qsValid = Turbine.UI.Lotro.Quickslot();
	self.qsValid:SetParent(self);
	self.qsValid:SetSize(self:GetWidth()-100,20);
	self.qsValid:SetPosition((self:GetWidth()-self.qsValid:GetWidth())/2, self:GetHeight()-30);
	self.qsValid:SetVisible(true);	
	self.qsValid:SetBackColor( Turbine.UI.Color( 0.6, 0, 0, 0 ) );
	self.qsValid:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/raid <rgb=#FF5CCD>TEMP MSG :P</rgb>"));	-- rose = FF5CCD
	self.qsValid:SetAllowDrop(false);
	self.qsValid:SetEnabled(false);
	
	-- A basic control on the quickslot for cosmetic purpose
	self.qsLbl = Turbine.UI.Control();
	self.qsLbl:SetParent(self);
	self.qsLbl:SetSize(self.qsValid:GetSize());
	self.qsLbl:SetPosition(self.qsValid:GetLeft(),self.qsValid:GetTop());
	self.qsLbl:SetMouseVisible(false);
	self.qsLbl:SetZOrder(10000);
	self.qsLbl:SetBackColor(Turbine.UI.Color( .7, .7, .7 ));
	
	-- A basic label on the basic control for cosmetic purpose ++
	c= Turbine.UI.Label()
	c:SetParent(self.qsLbl);
	c:SetPosition(1,1);
	c:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	c:SetSize(self.qsLbl:GetWidth()-2,self.qsLbl:GetHeight()-2);
	c:SetFontStyle(Turbine.UI.FontStyle.Outline);
	c:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	c:SetMouseVisible(false);
	c:SetZOrder(10001);
	c:SetText("Envoyer le message");	
	
	-- local applyButton = Turbine.UI.Lotro.Button();
	-- applyButton:SetParent( self );
	-- applyButton:SetSize(200,20);
	-- applyButton:SetPosition((self:GetWidth()-200)/2, 220);
	-- applyButton:SetText("G\195\169n\195\169rer l'Alias");
	-- applyButton.Click = function(sender, args)
		-- self:UpdateValidationButton();
	-- end	
end

-- Update the sending button
function PimpYourTextDialog:UpdateValidationButton()
	local text = FromUTF8(self.textArea:GetText());
	
	-- Apply rainbow colors
	if(self.selectedColor==self.colorList[table.getn(self.colorList)-1]) then
		-- TODO INSERT LENGTH TEST
		--Turbine.Shell.WriteLine("<rgb=#FF0000>ARC EN CIEL</rgb>");
		local rainbowList={"FF0000", "FFFF00", "00FF00", "38E5DF", "FF5CCD", "FF00FF"};
		local str = "";
		local colorCount = table.getn(rainbowList);
		local dec = math.random(colorCount);
		--Turbine.Shell.WriteLine("<rgb=#FF0000>dec = ".. dec .."</rgb>");
		for i = 1, text:len() do
			
			local c = text:sub(i,i);
			if(c==" " or c=="\n") then
				str = str..c;
			else
				str = str.."<rgb=#"..rainbowList[(i+dec)%colorCount+1]..">"..c;
			end			
		end
		--Turbine.Shell.WriteLine("str = "..str);
		text = str;
	elseif(self.colorArea:GetText()~="") then
		text = "<rgb=#"..self.colorArea:GetText()..">"..text.."</rgb>";
	end
	
	-- Apply MI command
	if(self.commandList[table.getn(self.commandList)]==self.command) then
		self.command = self.command.." "..self.destArea:GetText();
	end
	-- Apply Message of the Day command
	if(self.commandList[table.getn(self.commandList)-1]==self.command) then
		text = "\""..text.."\"";
	end	
	
	self.qsValid:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, self.command.." "..text));
end

function PimpYourTextDialog:GetName()
	return "PimpYourText";
end

function PimpYourTextDialog:IsRunning()
	return ( self ~= nil );
end

function PimpYourTextDialog:Start()
	if(self~=nil) then 
		self:SetVisible(true); 
	end
end

function PimpYourTextDialog:Stop()
	self = nil;
end
