ToolTip = class( Turbine.UI.Window );

function ToolTip:Constructor(parent, title, details, tooltipLayout, picto)
	Turbine.UI.Window.Constructor( self );

	local width, height = Turbine.UI.Display.GetSize();
	self.endDlg = nil;
	self:SetZOrder(999);
	self.mode = mode;
	
	self.Closed = function( sender, args )
		self:Stop();
	end
	
	local background = Turbine.UI.Label();
	background:SetParent( self );	
	background:SetPosition( 0, 0 );
	--background:SetSize(290, 324);
	background:SetMouseVisible( false );
	
	local icone = Turbine.UI.Label();
	icone:SetParent( self );	
	icone:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );	
	icone:SetPosition( 8, 12 );
	icone:SetSize(32, 32);
	icone:SetMouseVisible( false );	
	
	local label1 = Turbine.UI.Label();
	label1:SetParent( self );	
	label1:SetMouseVisible( false );
	label1:SetText(title);
	
	local label2 = Turbine.UI.Label();
	label2:SetParent( self );	
	label2:SetMouseVisible( false );		
	label2:SetText(details);
	
	if(tooltipLayout==nil) then
		tooltipLayout = ToolTipLayout.MIN;
	end
	if(picto~=nil) then
		icone:SetBackground("WalmPlugins/WarbandsSlayer/resources/"..picto);
	else
		icone:SetBackground(nil);
	end

	self:SetSize(tooltipLayout.width, tooltipLayout.height);
	background:SetSize(tooltipLayout.width, tooltipLayout.height);
	background:SetBackground(tooltipLayout.background);
	label1:SetPosition( tooltipLayout.title_x, tooltipLayout.title_y );
	label1:SetSize(tooltipLayout.title_width, tooltipLayout.title_height);
	label1:SetFont( tooltipLayout.title_font);
	if(tooltipLayout.title_fontstyle== Turbine.UI.FontStyle.Outline) then
		label1:SetFontStyle( tooltipLayout.title_fontstyle);
		label1:SetOutlineColor( tooltipLayout.title_outline_color);
	end	
	label1:SetForeColor( tooltipLayout.title_color);	
	label1:SetTextAlignment(tooltipLayout.title_alignement);
	label2:SetPosition(tooltipLayout.description_x, tooltipLayout.description_y);
	label2:SetSize(tooltipLayout.description_width, tooltipLayout.description_height);		
	
	parent.MouseEnter = function(sender, args)
		self:SetPosition( Turbine.UI.Display.GetMouseX()+20, Turbine.UI.Display.GetMouseY());
		self:Show();
	end
	parent.MouseLeave = function(sender, args)
		self:Stop();
	end		
end

function ToolTip:Show()
	if ( self ~= nil ) then
		--Turbine.Shell.WriteLine( "Rouverture");
		self:SetVisible( true );
	end	
end

function ToolTip:Free()
	self:SetParent(nil);
	self:Stop();
end

function ToolTip:Stop()	
	self:SetVisible(false);
end

ToolTipLayout = {
	MIN={
		background="WalmPlugins/WarbandsSlayer/resources/tooltip.tga",
		width=300, height=55,
		title_x=10, title_y=8, title_width=276, title_height=185,
		title_font = Turbine.UI.Lotro.Font.Undefined, title_fontstyle = Turbine.UI.FontStyle.Outline, title_color = Turbine.UI.Color( 197/255,162/255,57/255 ), 
		title_outline_color= Turbine.UI.Color( 0.3, 0.3, 0.3 ), title_alignement = Turbine.UI.ContentAlignmentUndefined,
		description_x=10, description_y=22, description_width=276, description_height=185,
		description_color = nil;
	},
	SMALL={
		background="WalmPlugins/WarbandsSlayer/resources/tooltip_small.tga",
		width=300, height=90,
		title_x=49, title_y=8, title_width=250, title_height=42,
		title_font = Turbine.UI.Lotro.Font.TrajanPro20 ,title_fontstyle = Turbine.UI.FontStyle.None, title_color = Turbine.UI.Color( 1, 1, 0), 
		title_outline_color=Turbine.UI.Color( 1, 1, 1), title_alignement = Turbine.UI.ContentAlignment.MiddleLeft,
		description_x=8, description_y=55, description_width=283, description_height=35,
		description_color = Turbine.UI.Color( 197/255,162/255,57/255 );
	},
	MEDIUM={
		background="WalmPlugins/WarbandsSlayer/resources/tooltip_medium.tga",
		width=300, height=150,
		title_x=49, title_y=8, title_width=250, title_height=42,
		title_font = Turbine.UI.Lotro.Font.TrajanPro20 ,title_fontstyle = Turbine.UI.FontStyle.None, title_color = Turbine.UI.Color( 1, 1, 0), 
		title_outline_color=Turbine.UI.Color( 1, 1, 1), title_alignement = Turbine.UI.ContentAlignment.MiddleLeft,
		description_x=8, description_y=55, description_width=283, description_height=140,
		description_color = Turbine.UI.Color( 197/255,162/255,57/255 );
	},
	LARGE={
		background="WalmPlugins/WarbandsSlayer/resources/tooltip_large.tga",
		width=299, height=200,
		title_x=49, title_y=8, title_width=250, title_height=42,
		title_font = Turbine.UI.Lotro.Font.TrajanPro20 ,title_fontstyle = Turbine.UI.FontStyle.None, title_color = Turbine.UI.Color( 1, 1, 0), 
		title_outline_color=Turbine.UI.Color( 1, 1, 1), title_alignement = Turbine.UI.ContentAlignment.MiddleLeft,
		description_x=5, description_y=55, description_width=293, description_height=140,
		description_color = Turbine.UI.Color( 197/255,162/255,57/255 );	
	},
	XSMALL_TEXTONLY={
		background="WalmPlugins/WarbandsSlayer/resources/tooltip.tga",
		width=300, height=55,
		title_x=49, title_y=8, title_width=0, title_height=0,
		title_font = Turbine.UI.Lotro.Font.TrajanPro20 ,title_fontstyle = Turbine.UI.FontStyle.None, title_color = Turbine.UI.Color( 1, 1, 0), 
		title_outline_color=Turbine.UI.Color( 1, 1, 1), title_alignement = Turbine.UI.ContentAlignment.MiddleLeft,
		description_x=8, description_y=8, description_width=283, description_height=80,
		description_color = Turbine.UI.Color( 197/255,162/255,57/255 );
	},		
	SMALL_TEXTONLY={
		background="WalmPlugins/WarbandsSlayer/resources/tooltip_small.tga",
		width=300, height=90,
		title_x=49, title_y=8, title_width=0, title_height=0,
		title_font = Turbine.UI.Lotro.Font.TrajanPro20 ,title_fontstyle = Turbine.UI.FontStyle.None, title_color = Turbine.UI.Color( 1, 1, 0), 
		title_outline_color=Turbine.UI.Color( 1, 1, 1), title_alignement = Turbine.UI.ContentAlignment.MiddleLeft,
		description_x=8, description_y=8, description_width=283, description_height=80,
		description_color = Turbine.UI.Color( 197/255,162/255,57/255 );
	},	
	MEDIUM_TEXTONLY={
		background="WalmPlugins/WarbandsSlayer/resources/tooltip_medium.tga",
		width=300, height=150,
		title_x=49, title_y=8, title_width=0, title_height=0,
		title_font = Turbine.UI.Lotro.Font.TrajanPro20 ,title_fontstyle = Turbine.UI.FontStyle.None, title_color = Turbine.UI.Color( 1, 1, 0), 
		title_outline_color=Turbine.UI.Color( 1, 1, 1), title_alignement = Turbine.UI.ContentAlignment.MiddleLeft,
		description_x=8, description_y=8, description_width=283, description_height=140,
		description_color = Turbine.UI.Color( 197/255,162/255,57/255 );	
	},
	LARGE_TEXTONLY={
		background="WalmPlugins/WarbandsSlayer/resources/tooltip_large.tga",
		width=299, height=200,
		title_x=49, title_y=8, title_width=0, title_height=0,
		title_font = Turbine.UI.Lotro.Font.TrajanPro20 ,title_fontstyle = Turbine.UI.FontStyle.None, title_color = Turbine.UI.Color( 1, 1, 0), 
		title_outline_color=Turbine.UI.Color( 1, 1, 1), title_alignement = Turbine.UI.ContentAlignment.MiddleLeft,
		description_x=5, description_y=5, description_width=293, description_height=190,
		description_color = Turbine.UI.Color( 197/255,162/255,57/255 );	
	};
};